var assert = require("assert");

describe('[thing-it] OSRAM Lightify Plugin', function () {
    var testDriver;

    before(function () {
        testDriver = require("thing-it-test").createTestDriver({logLevel: "error"});

        testDriver.registerDevicePlugin(__dirname + "/../lightifyGateway");
        testDriver.registerUnitPlugin(__dirname + "/../default-units/lightBulb");
        testDriver.registerUnitPlugin(__dirname + "/../default-units/led");
    });
    describe('Start Configuration', function () {
        this.timeout(10000);

        it('should complete without error', function (done) {
            setTimeout(function () {
                done();
            }.bind(this), 5000);

            testDriver.start({
                configuration: require("../examples/configuration.js"),
                heartbeat: 10
            });
        });
    });
    describe('LED off', function () {
        this.timeout(5000);

        before(function () {
            testDriver.removeAllListeners();
        });
        it('should produce Actor State Change message', function (done) {
            testDriver.addListener({
                publishActorStateChange: function (device, actor, state) {
                    if (actor.id === "led1Kitchen" && device.id === "lightifyGateway" && state.on === false) {
                        done();
                    }
                    /*else {
                        done('Unexpected Actor State Change message');
                    }*/
                }
            });

            testDriver.lightifyGateway.led1Kitchen.off();
            //testDriver.lightifyGateway.led2Kitchen.off();
            //testDriver.lightifyGateway.lightBulbLounge.softOff();
        });
    });
    describe('LED on', function () {
        this.timeout(5000);

        before(function () {
            testDriver.removeAllListeners();
        });
        it('should produce Actor State Change message', function (done) {
            testDriver.addListener({
                publishActorStateChange: function (device, actor, state) {
                    if (actor.id === "led1Kitchen" && device.id === "lightifyGateway" && state.on === true) {
                        done();
                    }
                    /*else {
                        done('Unexpected Actor State Change message');
                    }*/
                }
            });

            testDriver.lightifyGateway.led1Kitchen.on();
            //testDriver.lightifyGateway.led2Kitchen.off();
            //testDriver.lightifyGateway.lightBulbLounge.softOff();
        });
    });
    describe('LED brightness 50%', function () {
        this.timeout(5000);

        before(function () {
            testDriver.removeAllListeners();
        });
        it('should produce Actor State Change message', function (done) {
            testDriver.addListener({
                publishActorStateChange: function (device, actor, state) {
                    if (actor.id === "led1Kitchen" && device.id === "lightifyGateway" && state.brightnessPercent === 50) {
                        done();
                    }
                    //else {
                    //    done("Unexpected Actor State Change message.");
                    //}
                }
            });

            //testDriver.lightifyGateway.lightBulbLounge.softOn();
            testDriver.lightifyGateway.led1Kitchen.setBrightnessPercent({brightnessPercent: 50});
            //testDriver.lightifyGateway.led2Kitchen.on();
        });
    });
    describe('LED brightness 100%', function () {
        this.timeout(5000);

        before(function () {
            testDriver.removeAllListeners();
        });
        it('should produce Actor State Change message', function (done) {
            testDriver.addListener({
                publishActorStateChange: function (device, actor, state) {
                    if (actor.id === "led1Kitchen" && device.id === "lightifyGateway" && state.brightnessPercent === 100) {
                        done();
                    }
                    //else {
                    //    done("Unexpected Actor State Change message.");
                    //}
                }
            });

            //testDriver.lightifyGateway.lightBulbLounge.softOn();
            testDriver.lightifyGateway.led1Kitchen.setBrightnessPercent({brightnessPercent: 100});
            //testDriver.lightifyGateway.led2Kitchen.on();
        });
    });
    describe('LED brightness 0%', function () {
        this.timeout(5000);

        before(function () {
            testDriver.removeAllListeners();
        });
        it('should produce Actor State Change message', function (done) {
            testDriver.addListener({
                publishActorStateChange: function (device, actor, state) {
                    if (actor.id === "led1Kitchen" && device.id === "lightifyGateway" && state.brightnessPercent === 0) {
                        done();
                    }
                    //else {
                    //    done("Unexpected Actor State Change message.");
                    //}
                }
            });

            //testDriver.lightifyGateway.lightBulbLounge.softOn();
            testDriver.lightifyGateway.led1Kitchen.setBrightnessPercent({brightnessPercent: 0});
            //testDriver.lightifyGateway.led2Kitchen.on();
        });
    });
    describe('LED brightness 30%', function () {
        this.timeout(5000);

        before(function () {
            testDriver.removeAllListeners();
        });
        it('should produce Actor State Change message', function (done) {
            testDriver.addListener({
                publishActorStateChange: function (device, actor, state) {
                    if (actor.id === "led1Kitchen" && device.id === "lightifyGateway" && state.brightnessPercent === 30) {
                        done();
                    }
                    //else {
                    //    done("Unexpected Actor State Change message.");
                    //}
                }
            });

            //testDriver.lightifyGateway.lightBulbLounge.softOn();
            testDriver.lightifyGateway.led1Kitchen.setBrightnessPercent({brightnessPercent: 30});
            //testDriver.lightifyGateway.led2Kitchen.on();
        });
    });
    setTimeout(function () {
        this.timeout(5000);

        before(function () {
            testDriver.removeAllListeners();
        });
        it('should produce Actor State Change message', function (done) {
            testDriver.addListener({
                publishActorStateChange: function (device, actor, state) {
                    if (actor.id === "led1Kitchen" && device.id === "lightifyGateway" && state.brightnessPercent === 30) {
                        done();
                    }
                    //else {
                    //    done("Unexpected Actor State Change message.");
                    //}
                }
            });

            //testDriver.lightifyGateway.lightBulbLounge.softOn();
            testDriver.lightifyGateway.led1Kitchen.setBrightnessPercent({brightnessPercent: 30});
            //testDriver.lightifyGateway.led2Kitchen.on();
        });
    }.bind(this), 2000);
    setTimeout(function () {
        describe('LED brightness 50%', function () {
            this.timeout(5000);

            before(function () {
                testDriver.removeAllListeners();
            });
            it('should produce Actor State Change message', function (done) {
                testDriver.addListener({
                    publishActorStateChange: function (device, actor, state) {
                        if (actor.id === "led1Kitchen" && device.id === "lightifyGateway" && state.brightnessPercent === 30) {
                            done();
                        }
                        //else {
                        //    done("Unexpected Actor State Change message.");
                        //}
                    }
                });

                //testDriver.lightifyGateway.lightBulbLounge.softOn();
                testDriver.lightifyGateway.led1Kitchen.setBrightnessPercent({brightnessPercent: 30});
                //testDriver.lightifyGateway.led2Kitchen.on();
            });
        });
    }.bind(this), 2000);
    setTimeout(function () {
        describe('Light Bulb brightness 30%', function () {
            this.timeout(5000);

            before(function () {
                testDriver.removeAllListeners();
            });
            it('should produce Actor State Change message', function (done) {
                testDriver.addListener({
                    publishActorStateChange: function (device, actor, state) {
                        if (actor.id === "lightBulbLounge" && device.id === "lightifyGateway" && state.brightnessPercent === 30) {
                            done();
                        }
                        //else {
                        //    done("Unexpected Actor State Change message.");
                        //}
                    }
                });

                testDriver.lightifyGateway.lightBulbLounge.setBrightnessPercent({brightnessPercent: 30});
            });
        });

        setTimeout(function () {
            describe('Light Bulb brightness 100%', function () {
                this.timeout(5000);

                before(function () {
                    testDriver.removeAllListeners();
                });
                it('should produce Actor State Change message', function (done) {
                    testDriver.addListener({
                        publishActorStateChange: function (device, actor, state) {
                            if (actor.id === "lightBulbLounge" && device.id === "lightifyGateway" && state.brightnessPercent === 100) {
                                done();
                            }
                            //else {
                            //    done("Unexpected Actor State Change message.");
                            //}
                        }
                    });

                    testDriver.lightifyGateway.lightBulbLounge.setBrightnessPercent({brightnessPercent: 100});
                });
            });
        }.bind(this), 2000);
    }.bind(this), 2000);
});





